import org.lwjgl.glfw.*;
import org.lwjgl.opengl.GL;

import static org.lwjgl.glfw.GLFW.*;
import static org.lwjgl.opengl.GL11.*;
import static org.lwjgl.system.MemoryUtil.*;

public class cv04 {
	private int sirka = 800;
	private int vyska = 600;
	
	Vector3f[] vrcholy = {	new Vector3f(0,0,0), 
						new Vector3f(0.5f,0.5f,0)
					};

	void vykresliGL() {
		// Clear the screen and depth buffer
		glLoadIdentity();

		glPointSize(3);
		glBegin(GL_POINTS);
		glColor3f(1, 0, 0);
		for (Vector3f v : vrcholy) {
			glVertex2f(v.x, v.y);
		}
		glEnd();
	}

	long window;
	GLFWErrorCallback errorCallback;
	GLFWKeyCallback   keyCallback;

	void spusti() {
		try {
			init();
			loop();

			glfwDestroyWindow(window);
			keyCallback.free();
		} finally {
			glfwTerminate();
			errorCallback.free();
		}
	}

	void init() {
		glfwSetErrorCallback(errorCallback = GLFWErrorCallback.createPrint(System.err));
		if (!glfwInit())
			throw new IllegalStateException("Chyba pri inicializacii GLFW!!!");

		window = glfwCreateWindow(sirka, vyska, "UGR1", NULL, NULL);
		if ( window == NULL )
			throw new RuntimeException("Chyba pri vytvoreni GLFW okna!!!");

		glfwSetKeyCallback(window, keyCallback = new GLFWKeyCallback() {
			@Override
			public void invoke(long window, int key,
					int scancode, int action, int mods) {
				if (key == GLFW_KEY_ESCAPE && action == GLFW_RELEASE)
					glfwSetWindowShouldClose(window, true);
			}});

		GLFWVidMode vidmode = glfwGetVideoMode(glfwGetPrimaryMonitor());
		glfwSetWindowPos(window, (vidmode.width() - sirka) / 2, (vidmode.height() - vyska) / 2);

		glfwMakeContextCurrent(window);
		glfwSwapInterval(0);
		glfwShowWindow(window);        

		GL.createCapabilities();
		
	}


	void loop() {
		glViewport(0,0,sirka,vyska);        

        glMatrixMode(GL_PROJECTION);
        glLoadIdentity();
        glOrtho(-1, 1, -1, 1, 0, 1);

		glMatrixMode( GL_MODELVIEW ); 
		glLoadIdentity();

		glClearColor( 0.f, 0.f, 0.f, 1.f ); //Initialize clear color

		while ( !glfwWindowShouldClose(window) ) {
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
			vykresliGL();

			glfwSwapBuffers(window);

			glfwPollEvents();
		}
	}

	public static void main(String[] args) {
		new cv04().spusti();
	}
}

